/**
 * Autogenerated by Thrift
 *
 * DO NOT EDIT UNLESS YOU ARE SURE THAT YOU KNOW WHAT YOU ARE DOING
 */
package com.evernote.edam.notestore;

import java.util.List;
import java.util.ArrayList;
import java.util.Map;
import java.util.HashMap;
import java.util.Set;
import java.util.HashSet;

import com.evernote.thrift.*;
import com.evernote.thrift.protocol.*;

/**
 *  This structure is used with the 'getFilteredSyncChunk' call to provide
 *  fine-grained control over the data that's returned when a client needs
 *  to synchronize with the service. Each flag in this structure specifies
 *  whether to include one class of data in the results of that call.
 * 
 * <dl>
 *  <dt>includeNotes</dt>
 *    <dd>
 *    If true, then the server will include the SyncChunks.notes field
 *    </dd>
 * 
 *  <dt>includeNoteResources</dt>
 *    <dd>
 *    If true, then the server will include the 'resources' field on all of
 *    the Notes that are in SyncChunk.notes.
 *    If 'includeNotes' is false, then this will have no effect.
 *    </dd>
 * 
 *  <dt>includeNoteAttributes</dt>
 *    <dd>
 *    If true, then the server will include the 'attributes' field on all of
 *    the Notes that are in SyncChunks.notes.
 *    If 'includeNotes' is false, then this will have no effect.
 *    </dd>
 * 
 *  <dt>includeNotebooks</dt>
 *    <dd>
 *    If true, then the server will include the SyncChunks.notebooks field
 *    </dd>
 * 
 *  <dt>includeTags</dt>
 *    <dd>
 *    If true, then the server will include the SyncChunks.tags field
 *    </dd>
 * 
 *  <dt>includeSearches</dt>
 *    <dd>
 *    If true, then the server will include the SyncChunks.searches field
 *    </dd>
 * 
 *  <dt>includeResources</dt>
 *    <dd>
 *    If true, then the server will include the SyncChunks.resources field.
 *    Since the Resources are also provided with their Note
 *    (in the Notes.resources list), this is primarily useful for clients that
 *    want to watch for changes to individual Resources due to recognition data
 *    being added.
 *    </dd>
 * 
 *  <dt>includeLinkedNotebooks</dt>
 *    <dd>
 *    If true, then the server will include the SyncChunks.linkedNotebooks field.
 *    </dd>
 * 
 *  <dt>includeExpunged</dt>
 *    <dd>
 *    If true, then the server will include the 'expunged' data for any type
 *    of included data.  For example, if 'includeTags' and 'includeExpunged'
 *    are both true, then the SyncChunks.expungedTags field will be set with
 *    the GUIDs of tags that have been expunged from the server.
 *    </dd>
 * 
 *  <dt>includeNoteApplicationDataFullMap</dt>
 *    <dd>
 *    If true, then the values for the applicationData map will be filled
 *    in, assuming notes and note attributes are being returned.  Otherwise,
 *    only the keysOnly field will be filled in.
 *    </dd>
 * 
 *  <dt>includeResourceApplicationDataFullMap</dt>
 *    <dd>
 *    If true, then the fullMap values for the applicationData map will be
 *    filled in, assuming resources and resource attributes are being returned
 *    (includeResources is true).  Otherwise, only the keysOnly field will be
 *    filled in.
 *    </dd>
 * 
 *  <dt>includeNoteResourceApplicationDataFullMap</dt>
 *    <dd>
 *    If true, then the fullMap values for the applicationData map will be
 *    filled in for resources found inside of notes, assuming resources are
 *    being returned in notes (includeNoteResources is true).  Otherwise,
 *    only the keysOnly field will be filled in.
 *    </dd>
 * 
 *  <dt>requireNoteContentClass</dt>
 *    <dd>
 *    If set, then only send notes whose content class matches this value.
 *    The value can be a literal match or, if the last character is an
 *    asterisk, a prefix match.
 *    </dd>
 *  </dl>
 */
public class SyncChunkFilter implements TBase<SyncChunkFilter>, java.io.Serializable, Cloneable {
  private static final TStruct STRUCT_DESC = new TStruct("SyncChunkFilter");

  private static final TField INCLUDE_NOTES_FIELD_DESC = new TField("includeNotes", TType.BOOL, (short)1);
  private static final TField INCLUDE_NOTE_RESOURCES_FIELD_DESC = new TField("includeNoteResources", TType.BOOL, (short)2);
  private static final TField INCLUDE_NOTE_ATTRIBUTES_FIELD_DESC = new TField("includeNoteAttributes", TType.BOOL, (short)3);
  private static final TField INCLUDE_NOTEBOOKS_FIELD_DESC = new TField("includeNotebooks", TType.BOOL, (short)4);
  private static final TField INCLUDE_TAGS_FIELD_DESC = new TField("includeTags", TType.BOOL, (short)5);
  private static final TField INCLUDE_SEARCHES_FIELD_DESC = new TField("includeSearches", TType.BOOL, (short)6);
  private static final TField INCLUDE_RESOURCES_FIELD_DESC = new TField("includeResources", TType.BOOL, (short)7);
  private static final TField INCLUDE_LINKED_NOTEBOOKS_FIELD_DESC = new TField("includeLinkedNotebooks", TType.BOOL, (short)8);
  private static final TField INCLUDE_EXPUNGED_FIELD_DESC = new TField("includeExpunged", TType.BOOL, (short)9);
  private static final TField INCLUDE_NOTE_APPLICATION_DATA_FULL_MAP_FIELD_DESC = new TField("includeNoteApplicationDataFullMap", TType.BOOL, (short)10);
  private static final TField INCLUDE_RESOURCE_APPLICATION_DATA_FULL_MAP_FIELD_DESC = new TField("includeResourceApplicationDataFullMap", TType.BOOL, (short)12);
  private static final TField INCLUDE_NOTE_RESOURCE_APPLICATION_DATA_FULL_MAP_FIELD_DESC = new TField("includeNoteResourceApplicationDataFullMap", TType.BOOL, (short)13);
  private static final TField REQUIRE_NOTE_CONTENT_CLASS_FIELD_DESC = new TField("requireNoteContentClass", TType.STRING, (short)11);

  private boolean includeNotes;
  private boolean includeNoteResources;
  private boolean includeNoteAttributes;
  private boolean includeNotebooks;
  private boolean includeTags;
  private boolean includeSearches;
  private boolean includeResources;
  private boolean includeLinkedNotebooks;
  private boolean includeExpunged;
  private boolean includeNoteApplicationDataFullMap;
  private boolean includeResourceApplicationDataFullMap;
  private boolean includeNoteResourceApplicationDataFullMap;
  private String requireNoteContentClass;


  // isset id assignments
  private static final int __INCLUDENOTES_ISSET_ID = 0;
  private static final int __INCLUDENOTERESOURCES_ISSET_ID = 1;
  private static final int __INCLUDENOTEATTRIBUTES_ISSET_ID = 2;
  private static final int __INCLUDENOTEBOOKS_ISSET_ID = 3;
  private static final int __INCLUDETAGS_ISSET_ID = 4;
  private static final int __INCLUDESEARCHES_ISSET_ID = 5;
  private static final int __INCLUDERESOURCES_ISSET_ID = 6;
  private static final int __INCLUDELINKEDNOTEBOOKS_ISSET_ID = 7;
  private static final int __INCLUDEEXPUNGED_ISSET_ID = 8;
  private static final int __INCLUDENOTEAPPLICATIONDATAFULLMAP_ISSET_ID = 9;
  private static final int __INCLUDERESOURCEAPPLICATIONDATAFULLMAP_ISSET_ID = 10;
  private static final int __INCLUDENOTERESOURCEAPPLICATIONDATAFULLMAP_ISSET_ID = 11;
  private boolean[] __isset_vector = new boolean[12];

  public SyncChunkFilter() {
  }

  /**
   * Performs a deep copy on <i>other</i>.
   */
  public SyncChunkFilter(SyncChunkFilter other) {
    System.arraycopy(other.__isset_vector, 0, __isset_vector, 0, other.__isset_vector.length);
    this.includeNotes = other.includeNotes;
    this.includeNoteResources = other.includeNoteResources;
    this.includeNoteAttributes = other.includeNoteAttributes;
    this.includeNotebooks = other.includeNotebooks;
    this.includeTags = other.includeTags;
    this.includeSearches = other.includeSearches;
    this.includeResources = other.includeResources;
    this.includeLinkedNotebooks = other.includeLinkedNotebooks;
    this.includeExpunged = other.includeExpunged;
    this.includeNoteApplicationDataFullMap = other.includeNoteApplicationDataFullMap;
    this.includeResourceApplicationDataFullMap = other.includeResourceApplicationDataFullMap;
    this.includeNoteResourceApplicationDataFullMap = other.includeNoteResourceApplicationDataFullMap;
    if (other.isSetRequireNoteContentClass()) {
      this.requireNoteContentClass = other.requireNoteContentClass;
    }
  }

  public SyncChunkFilter deepCopy() {
    return new SyncChunkFilter(this);
  }

  public void clear() {
    setIncludeNotesIsSet(false);
    this.includeNotes = false;
    setIncludeNoteResourcesIsSet(false);
    this.includeNoteResources = false;
    setIncludeNoteAttributesIsSet(false);
    this.includeNoteAttributes = false;
    setIncludeNotebooksIsSet(false);
    this.includeNotebooks = false;
    setIncludeTagsIsSet(false);
    this.includeTags = false;
    setIncludeSearchesIsSet(false);
    this.includeSearches = false;
    setIncludeResourcesIsSet(false);
    this.includeResources = false;
    setIncludeLinkedNotebooksIsSet(false);
    this.includeLinkedNotebooks = false;
    setIncludeExpungedIsSet(false);
    this.includeExpunged = false;
    setIncludeNoteApplicationDataFullMapIsSet(false);
    this.includeNoteApplicationDataFullMap = false;
    setIncludeResourceApplicationDataFullMapIsSet(false);
    this.includeResourceApplicationDataFullMap = false;
    setIncludeNoteResourceApplicationDataFullMapIsSet(false);
    this.includeNoteResourceApplicationDataFullMap = false;
    this.requireNoteContentClass = null;
  }

  public boolean isIncludeNotes() {
    return this.includeNotes;
  }

  public void setIncludeNotes(boolean includeNotes) {
    this.includeNotes = includeNotes;
    setIncludeNotesIsSet(true);
  }

  public void unsetIncludeNotes() {
    __isset_vector[__INCLUDENOTES_ISSET_ID] = false;
  }

  /** Returns true if field includeNotes is set (has been asigned a value) and false otherwise */
  public boolean isSetIncludeNotes() {
    return __isset_vector[__INCLUDENOTES_ISSET_ID];
  }

  public void setIncludeNotesIsSet(boolean value) {
    __isset_vector[__INCLUDENOTES_ISSET_ID] = value;
  }

  public boolean isIncludeNoteResources() {
    return this.includeNoteResources;
  }

  public void setIncludeNoteResources(boolean includeNoteResources) {
    this.includeNoteResources = includeNoteResources;
    setIncludeNoteResourcesIsSet(true);
  }

  public void unsetIncludeNoteResources() {
    __isset_vector[__INCLUDENOTERESOURCES_ISSET_ID] = false;
  }

  /** Returns true if field includeNoteResources is set (has been asigned a value) and false otherwise */
  public boolean isSetIncludeNoteResources() {
    return __isset_vector[__INCLUDENOTERESOURCES_ISSET_ID];
  }

  public void setIncludeNoteResourcesIsSet(boolean value) {
    __isset_vector[__INCLUDENOTERESOURCES_ISSET_ID] = value;
  }

  public boolean isIncludeNoteAttributes() {
    return this.includeNoteAttributes;
  }

  public void setIncludeNoteAttributes(boolean includeNoteAttributes) {
    this.includeNoteAttributes = includeNoteAttributes;
    setIncludeNoteAttributesIsSet(true);
  }

  public void unsetIncludeNoteAttributes() {
    __isset_vector[__INCLUDENOTEATTRIBUTES_ISSET_ID] = false;
  }

  /** Returns true if field includeNoteAttributes is set (has been asigned a value) and false otherwise */
  public boolean isSetIncludeNoteAttributes() {
    return __isset_vector[__INCLUDENOTEATTRIBUTES_ISSET_ID];
  }

  public void setIncludeNoteAttributesIsSet(boolean value) {
    __isset_vector[__INCLUDENOTEATTRIBUTES_ISSET_ID] = value;
  }

  public boolean isIncludeNotebooks() {
    return this.includeNotebooks;
  }

  public void setIncludeNotebooks(boolean includeNotebooks) {
    this.includeNotebooks = includeNotebooks;
    setIncludeNotebooksIsSet(true);
  }

  public void unsetIncludeNotebooks() {
    __isset_vector[__INCLUDENOTEBOOKS_ISSET_ID] = false;
  }

  /** Returns true if field includeNotebooks is set (has been asigned a value) and false otherwise */
  public boolean isSetIncludeNotebooks() {
    return __isset_vector[__INCLUDENOTEBOOKS_ISSET_ID];
  }

  public void setIncludeNotebooksIsSet(boolean value) {
    __isset_vector[__INCLUDENOTEBOOKS_ISSET_ID] = value;
  }

  public boolean isIncludeTags() {
    return this.includeTags;
  }

  public void setIncludeTags(boolean includeTags) {
    this.includeTags = includeTags;
    setIncludeTagsIsSet(true);
  }

  public void unsetIncludeTags() {
    __isset_vector[__INCLUDETAGS_ISSET_ID] = false;
  }

  /** Returns true if field includeTags is set (has been asigned a value) and false otherwise */
  public boolean isSetIncludeTags() {
    return __isset_vector[__INCLUDETAGS_ISSET_ID];
  }

  public void setIncludeTagsIsSet(boolean value) {
    __isset_vector[__INCLUDETAGS_ISSET_ID] = value;
  }

  public boolean isIncludeSearches() {
    return this.includeSearches;
  }

  public void setIncludeSearches(boolean includeSearches) {
    this.includeSearches = includeSearches;
    setIncludeSearchesIsSet(true);
  }

  public void unsetIncludeSearches() {
    __isset_vector[__INCLUDESEARCHES_ISSET_ID] = false;
  }

  /** Returns true if field includeSearches is set (has been asigned a value) and false otherwise */
  public boolean isSetIncludeSearches() {
    return __isset_vector[__INCLUDESEARCHES_ISSET_ID];
  }

  public void setIncludeSearchesIsSet(boolean value) {
    __isset_vector[__INCLUDESEARCHES_ISSET_ID] = value;
  }

  public boolean isIncludeResources() {
    return this.includeResources;
  }

  public void setIncludeResources(boolean includeResources) {
    this.includeResources = includeResources;
    setIncludeResourcesIsSet(true);
  }

  public void unsetIncludeResources() {
    __isset_vector[__INCLUDERESOURCES_ISSET_ID] = false;
  }

  /** Returns true if field includeResources is set (has been asigned a value) and false otherwise */
  public boolean isSetIncludeResources() {
    return __isset_vector[__INCLUDERESOURCES_ISSET_ID];
  }

  public void setIncludeResourcesIsSet(boolean value) {
    __isset_vector[__INCLUDERESOURCES_ISSET_ID] = value;
  }

  public boolean isIncludeLinkedNotebooks() {
    return this.includeLinkedNotebooks;
  }

  public void setIncludeLinkedNotebooks(boolean includeLinkedNotebooks) {
    this.includeLinkedNotebooks = includeLinkedNotebooks;
    setIncludeLinkedNotebooksIsSet(true);
  }

  public void unsetIncludeLinkedNotebooks() {
    __isset_vector[__INCLUDELINKEDNOTEBOOKS_ISSET_ID] = false;
  }

  /** Returns true if field includeLinkedNotebooks is set (has been asigned a value) and false otherwise */
  public boolean isSetIncludeLinkedNotebooks() {
    return __isset_vector[__INCLUDELINKEDNOTEBOOKS_ISSET_ID];
  }

  public void setIncludeLinkedNotebooksIsSet(boolean value) {
    __isset_vector[__INCLUDELINKEDNOTEBOOKS_ISSET_ID] = value;
  }

  public boolean isIncludeExpunged() {
    return this.includeExpunged;
  }

  public void setIncludeExpunged(boolean includeExpunged) {
    this.includeExpunged = includeExpunged;
    setIncludeExpungedIsSet(true);
  }

  public void unsetIncludeExpunged() {
    __isset_vector[__INCLUDEEXPUNGED_ISSET_ID] = false;
  }

  /** Returns true if field includeExpunged is set (has been asigned a value) and false otherwise */
  public boolean isSetIncludeExpunged() {
    return __isset_vector[__INCLUDEEXPUNGED_ISSET_ID];
  }

  public void setIncludeExpungedIsSet(boolean value) {
    __isset_vector[__INCLUDEEXPUNGED_ISSET_ID] = value;
  }

  public boolean isIncludeNoteApplicationDataFullMap() {
    return this.includeNoteApplicationDataFullMap;
  }

  public void setIncludeNoteApplicationDataFullMap(boolean includeNoteApplicationDataFullMap) {
    this.includeNoteApplicationDataFullMap = includeNoteApplicationDataFullMap;
    setIncludeNoteApplicationDataFullMapIsSet(true);
  }

  public void unsetIncludeNoteApplicationDataFullMap() {
    __isset_vector[__INCLUDENOTEAPPLICATIONDATAFULLMAP_ISSET_ID] = false;
  }

  /** Returns true if field includeNoteApplicationDataFullMap is set (has been asigned a value) and false otherwise */
  public boolean isSetIncludeNoteApplicationDataFullMap() {
    return __isset_vector[__INCLUDENOTEAPPLICATIONDATAFULLMAP_ISSET_ID];
  }

  public void setIncludeNoteApplicationDataFullMapIsSet(boolean value) {
    __isset_vector[__INCLUDENOTEAPPLICATIONDATAFULLMAP_ISSET_ID] = value;
  }

  public boolean isIncludeResourceApplicationDataFullMap() {
    return this.includeResourceApplicationDataFullMap;
  }

  public void setIncludeResourceApplicationDataFullMap(boolean includeResourceApplicationDataFullMap) {
    this.includeResourceApplicationDataFullMap = includeResourceApplicationDataFullMap;
    setIncludeResourceApplicationDataFullMapIsSet(true);
  }

  public void unsetIncludeResourceApplicationDataFullMap() {
    __isset_vector[__INCLUDERESOURCEAPPLICATIONDATAFULLMAP_ISSET_ID] = false;
  }

  /** Returns true if field includeResourceApplicationDataFullMap is set (has been asigned a value) and false otherwise */
  public boolean isSetIncludeResourceApplicationDataFullMap() {
    return __isset_vector[__INCLUDERESOURCEAPPLICATIONDATAFULLMAP_ISSET_ID];
  }

  public void setIncludeResourceApplicationDataFullMapIsSet(boolean value) {
    __isset_vector[__INCLUDERESOURCEAPPLICATIONDATAFULLMAP_ISSET_ID] = value;
  }

  public boolean isIncludeNoteResourceApplicationDataFullMap() {
    return this.includeNoteResourceApplicationDataFullMap;
  }

  public void setIncludeNoteResourceApplicationDataFullMap(boolean includeNoteResourceApplicationDataFullMap) {
    this.includeNoteResourceApplicationDataFullMap = includeNoteResourceApplicationDataFullMap;
    setIncludeNoteResourceApplicationDataFullMapIsSet(true);
  }

  public void unsetIncludeNoteResourceApplicationDataFullMap() {
    __isset_vector[__INCLUDENOTERESOURCEAPPLICATIONDATAFULLMAP_ISSET_ID] = false;
  }

  /** Returns true if field includeNoteResourceApplicationDataFullMap is set (has been asigned a value) and false otherwise */
  public boolean isSetIncludeNoteResourceApplicationDataFullMap() {
    return __isset_vector[__INCLUDENOTERESOURCEAPPLICATIONDATAFULLMAP_ISSET_ID];
  }

  public void setIncludeNoteResourceApplicationDataFullMapIsSet(boolean value) {
    __isset_vector[__INCLUDENOTERESOURCEAPPLICATIONDATAFULLMAP_ISSET_ID] = value;
  }

  public String getRequireNoteContentClass() {
    return this.requireNoteContentClass;
  }

  public void setRequireNoteContentClass(String requireNoteContentClass) {
    this.requireNoteContentClass = requireNoteContentClass;
  }

  public void unsetRequireNoteContentClass() {
    this.requireNoteContentClass = null;
  }

  /** Returns true if field requireNoteContentClass is set (has been asigned a value) and false otherwise */
  public boolean isSetRequireNoteContentClass() {
    return this.requireNoteContentClass != null;
  }

  public void setRequireNoteContentClassIsSet(boolean value) {
    if (!value) {
      this.requireNoteContentClass = null;
    }
  }

  @Override
  public boolean equals(Object that) {
    if (that == null)
      return false;
    if (that instanceof SyncChunkFilter)
      return this.equals((SyncChunkFilter)that);
    return false;
  }

  public boolean equals(SyncChunkFilter that) {
    if (that == null)
      return false;

    boolean this_present_includeNotes = true && this.isSetIncludeNotes();
    boolean that_present_includeNotes = true && that.isSetIncludeNotes();
    if (this_present_includeNotes || that_present_includeNotes) {
      if (!(this_present_includeNotes && that_present_includeNotes))
        return false;
      if (this.includeNotes != that.includeNotes)
        return false;
    }

    boolean this_present_includeNoteResources = true && this.isSetIncludeNoteResources();
    boolean that_present_includeNoteResources = true && that.isSetIncludeNoteResources();
    if (this_present_includeNoteResources || that_present_includeNoteResources) {
      if (!(this_present_includeNoteResources && that_present_includeNoteResources))
        return false;
      if (this.includeNoteResources != that.includeNoteResources)
        return false;
    }

    boolean this_present_includeNoteAttributes = true && this.isSetIncludeNoteAttributes();
    boolean that_present_includeNoteAttributes = true && that.isSetIncludeNoteAttributes();
    if (this_present_includeNoteAttributes || that_present_includeNoteAttributes) {
      if (!(this_present_includeNoteAttributes && that_present_includeNoteAttributes))
        return false;
      if (this.includeNoteAttributes != that.includeNoteAttributes)
        return false;
    }

    boolean this_present_includeNotebooks = true && this.isSetIncludeNotebooks();
    boolean that_present_includeNotebooks = true && that.isSetIncludeNotebooks();
    if (this_present_includeNotebooks || that_present_includeNotebooks) {
      if (!(this_present_includeNotebooks && that_present_includeNotebooks))
        return false;
      if (this.includeNotebooks != that.includeNotebooks)
        return false;
    }

    boolean this_present_includeTags = true && this.isSetIncludeTags();
    boolean that_present_includeTags = true && that.isSetIncludeTags();
    if (this_present_includeTags || that_present_includeTags) {
      if (!(this_present_includeTags && that_present_includeTags))
        return false;
      if (this.includeTags != that.includeTags)
        return false;
    }

    boolean this_present_includeSearches = true && this.isSetIncludeSearches();
    boolean that_present_includeSearches = true && that.isSetIncludeSearches();
    if (this_present_includeSearches || that_present_includeSearches) {
      if (!(this_present_includeSearches && that_present_includeSearches))
        return false;
      if (this.includeSearches != that.includeSearches)
        return false;
    }

    boolean this_present_includeResources = true && this.isSetIncludeResources();
    boolean that_present_includeResources = true && that.isSetIncludeResources();
    if (this_present_includeResources || that_present_includeResources) {
      if (!(this_present_includeResources && that_present_includeResources))
        return false;
      if (this.includeResources != that.includeResources)
        return false;
    }

    boolean this_present_includeLinkedNotebooks = true && this.isSetIncludeLinkedNotebooks();
    boolean that_present_includeLinkedNotebooks = true && that.isSetIncludeLinkedNotebooks();
    if (this_present_includeLinkedNotebooks || that_present_includeLinkedNotebooks) {
      if (!(this_present_includeLinkedNotebooks && that_present_includeLinkedNotebooks))
        return false;
      if (this.includeLinkedNotebooks != that.includeLinkedNotebooks)
        return false;
    }

    boolean this_present_includeExpunged = true && this.isSetIncludeExpunged();
    boolean that_present_includeExpunged = true && that.isSetIncludeExpunged();
    if (this_present_includeExpunged || that_present_includeExpunged) {
      if (!(this_present_includeExpunged && that_present_includeExpunged))
        return false;
      if (this.includeExpunged != that.includeExpunged)
        return false;
    }

    boolean this_present_includeNoteApplicationDataFullMap = true && this.isSetIncludeNoteApplicationDataFullMap();
    boolean that_present_includeNoteApplicationDataFullMap = true && that.isSetIncludeNoteApplicationDataFullMap();
    if (this_present_includeNoteApplicationDataFullMap || that_present_includeNoteApplicationDataFullMap) {
      if (!(this_present_includeNoteApplicationDataFullMap && that_present_includeNoteApplicationDataFullMap))
        return false;
      if (this.includeNoteApplicationDataFullMap != that.includeNoteApplicationDataFullMap)
        return false;
    }

    boolean this_present_includeResourceApplicationDataFullMap = true && this.isSetIncludeResourceApplicationDataFullMap();
    boolean that_present_includeResourceApplicationDataFullMap = true && that.isSetIncludeResourceApplicationDataFullMap();
    if (this_present_includeResourceApplicationDataFullMap || that_present_includeResourceApplicationDataFullMap) {
      if (!(this_present_includeResourceApplicationDataFullMap && that_present_includeResourceApplicationDataFullMap))
        return false;
      if (this.includeResourceApplicationDataFullMap != that.includeResourceApplicationDataFullMap)
        return false;
    }

    boolean this_present_includeNoteResourceApplicationDataFullMap = true && this.isSetIncludeNoteResourceApplicationDataFullMap();
    boolean that_present_includeNoteResourceApplicationDataFullMap = true && that.isSetIncludeNoteResourceApplicationDataFullMap();
    if (this_present_includeNoteResourceApplicationDataFullMap || that_present_includeNoteResourceApplicationDataFullMap) {
      if (!(this_present_includeNoteResourceApplicationDataFullMap && that_present_includeNoteResourceApplicationDataFullMap))
        return false;
      if (this.includeNoteResourceApplicationDataFullMap != that.includeNoteResourceApplicationDataFullMap)
        return false;
    }

    boolean this_present_requireNoteContentClass = true && this.isSetRequireNoteContentClass();
    boolean that_present_requireNoteContentClass = true && that.isSetRequireNoteContentClass();
    if (this_present_requireNoteContentClass || that_present_requireNoteContentClass) {
      if (!(this_present_requireNoteContentClass && that_present_requireNoteContentClass))
        return false;
      if (!this.requireNoteContentClass.equals(that.requireNoteContentClass))
        return false;
    }

    return true;
  }

  @Override
  public int hashCode() {
    return 0;
  }

  public int compareTo(SyncChunkFilter other) {
    if (!getClass().equals(other.getClass())) {
      return getClass().getName().compareTo(other.getClass().getName());
    }

    int lastComparison = 0;
    SyncChunkFilter typedOther = (SyncChunkFilter)other;

    lastComparison = Boolean.valueOf(isSetIncludeNotes()).compareTo(typedOther.isSetIncludeNotes());
    if (lastComparison != 0) {
      return lastComparison;
    }
    if (isSetIncludeNotes()) {      lastComparison = TBaseHelper.compareTo(this.includeNotes, typedOther.includeNotes);
      if (lastComparison != 0) {
        return lastComparison;
      }
    }
    lastComparison = Boolean.valueOf(isSetIncludeNoteResources()).compareTo(typedOther.isSetIncludeNoteResources());
    if (lastComparison != 0) {
      return lastComparison;
    }
    if (isSetIncludeNoteResources()) {      lastComparison = TBaseHelper.compareTo(this.includeNoteResources, typedOther.includeNoteResources);
      if (lastComparison != 0) {
        return lastComparison;
      }
    }
    lastComparison = Boolean.valueOf(isSetIncludeNoteAttributes()).compareTo(typedOther.isSetIncludeNoteAttributes());
    if (lastComparison != 0) {
      return lastComparison;
    }
    if (isSetIncludeNoteAttributes()) {      lastComparison = TBaseHelper.compareTo(this.includeNoteAttributes, typedOther.includeNoteAttributes);
      if (lastComparison != 0) {
        return lastComparison;
      }
    }
    lastComparison = Boolean.valueOf(isSetIncludeNotebooks()).compareTo(typedOther.isSetIncludeNotebooks());
    if (lastComparison != 0) {
      return lastComparison;
    }
    if (isSetIncludeNotebooks()) {      lastComparison = TBaseHelper.compareTo(this.includeNotebooks, typedOther.includeNotebooks);
      if (lastComparison != 0) {
        return lastComparison;
      }
    }
    lastComparison = Boolean.valueOf(isSetIncludeTags()).compareTo(typedOther.isSetIncludeTags());
    if (lastComparison != 0) {
      return lastComparison;
    }
    if (isSetIncludeTags()) {      lastComparison = TBaseHelper.compareTo(this.includeTags, typedOther.includeTags);
      if (lastComparison != 0) {
        return lastComparison;
      }
    }
    lastComparison = Boolean.valueOf(isSetIncludeSearches()).compareTo(typedOther.isSetIncludeSearches());
    if (lastComparison != 0) {
      return lastComparison;
    }
    if (isSetIncludeSearches()) {      lastComparison = TBaseHelper.compareTo(this.includeSearches, typedOther.includeSearches);
      if (lastComparison != 0) {
        return lastComparison;
      }
    }
    lastComparison = Boolean.valueOf(isSetIncludeResources()).compareTo(typedOther.isSetIncludeResources());
    if (lastComparison != 0) {
      return lastComparison;
    }
    if (isSetIncludeResources()) {      lastComparison = TBaseHelper.compareTo(this.includeResources, typedOther.includeResources);
      if (lastComparison != 0) {
        return lastComparison;
      }
    }
    lastComparison = Boolean.valueOf(isSetIncludeLinkedNotebooks()).compareTo(typedOther.isSetIncludeLinkedNotebooks());
    if (lastComparison != 0) {
      return lastComparison;
    }
    if (isSetIncludeLinkedNotebooks()) {      lastComparison = TBaseHelper.compareTo(this.includeLinkedNotebooks, typedOther.includeLinkedNotebooks);
      if (lastComparison != 0) {
        return lastComparison;
      }
    }
    lastComparison = Boolean.valueOf(isSetIncludeExpunged()).compareTo(typedOther.isSetIncludeExpunged());
    if (lastComparison != 0) {
      return lastComparison;
    }
    if (isSetIncludeExpunged()) {      lastComparison = TBaseHelper.compareTo(this.includeExpunged, typedOther.includeExpunged);
      if (lastComparison != 0) {
        return lastComparison;
      }
    }
    lastComparison = Boolean.valueOf(isSetIncludeNoteApplicationDataFullMap()).compareTo(typedOther.isSetIncludeNoteApplicationDataFullMap());
    if (lastComparison != 0) {
      return lastComparison;
    }
    if (isSetIncludeNoteApplicationDataFullMap()) {      lastComparison = TBaseHelper.compareTo(this.includeNoteApplicationDataFullMap, typedOther.includeNoteApplicationDataFullMap);
      if (lastComparison != 0) {
        return lastComparison;
      }
    }
    lastComparison = Boolean.valueOf(isSetIncludeResourceApplicationDataFullMap()).compareTo(typedOther.isSetIncludeResourceApplicationDataFullMap());
    if (lastComparison != 0) {
      return lastComparison;
    }
    if (isSetIncludeResourceApplicationDataFullMap()) {      lastComparison = TBaseHelper.compareTo(this.includeResourceApplicationDataFullMap, typedOther.includeResourceApplicationDataFullMap);
      if (lastComparison != 0) {
        return lastComparison;
      }
    }
    lastComparison = Boolean.valueOf(isSetIncludeNoteResourceApplicationDataFullMap()).compareTo(typedOther.isSetIncludeNoteResourceApplicationDataFullMap());
    if (lastComparison != 0) {
      return lastComparison;
    }
    if (isSetIncludeNoteResourceApplicationDataFullMap()) {      lastComparison = TBaseHelper.compareTo(this.includeNoteResourceApplicationDataFullMap, typedOther.includeNoteResourceApplicationDataFullMap);
      if (lastComparison != 0) {
        return lastComparison;
      }
    }
    lastComparison = Boolean.valueOf(isSetRequireNoteContentClass()).compareTo(typedOther.isSetRequireNoteContentClass());
    if (lastComparison != 0) {
      return lastComparison;
    }
    if (isSetRequireNoteContentClass()) {      lastComparison = TBaseHelper.compareTo(this.requireNoteContentClass, typedOther.requireNoteContentClass);
      if (lastComparison != 0) {
        return lastComparison;
      }
    }
    return 0;
  }

  public void read(TProtocol iprot) throws TException {
    TField field;
    iprot.readStructBegin();
    while (true)
    {
      field = iprot.readFieldBegin();
      if (field.type == TType.STOP) { 
        break;
      }
      switch (field.id) {
        case 1: // INCLUDE_NOTES
          if (field.type == TType.BOOL) {
            this.includeNotes = iprot.readBool();
            setIncludeNotesIsSet(true);
          } else { 
            TProtocolUtil.skip(iprot, field.type);
          }
          break;
        case 2: // INCLUDE_NOTE_RESOURCES
          if (field.type == TType.BOOL) {
            this.includeNoteResources = iprot.readBool();
            setIncludeNoteResourcesIsSet(true);
          } else { 
            TProtocolUtil.skip(iprot, field.type);
          }
          break;
        case 3: // INCLUDE_NOTE_ATTRIBUTES
          if (field.type == TType.BOOL) {
            this.includeNoteAttributes = iprot.readBool();
            setIncludeNoteAttributesIsSet(true);
          } else { 
            TProtocolUtil.skip(iprot, field.type);
          }
          break;
        case 4: // INCLUDE_NOTEBOOKS
          if (field.type == TType.BOOL) {
            this.includeNotebooks = iprot.readBool();
            setIncludeNotebooksIsSet(true);
          } else { 
            TProtocolUtil.skip(iprot, field.type);
          }
          break;
        case 5: // INCLUDE_TAGS
          if (field.type == TType.BOOL) {
            this.includeTags = iprot.readBool();
            setIncludeTagsIsSet(true);
          } else { 
            TProtocolUtil.skip(iprot, field.type);
          }
          break;
        case 6: // INCLUDE_SEARCHES
          if (field.type == TType.BOOL) {
            this.includeSearches = iprot.readBool();
            setIncludeSearchesIsSet(true);
          } else { 
            TProtocolUtil.skip(iprot, field.type);
          }
          break;
        case 7: // INCLUDE_RESOURCES
          if (field.type == TType.BOOL) {
            this.includeResources = iprot.readBool();
            setIncludeResourcesIsSet(true);
          } else { 
            TProtocolUtil.skip(iprot, field.type);
          }
          break;
        case 8: // INCLUDE_LINKED_NOTEBOOKS
          if (field.type == TType.BOOL) {
            this.includeLinkedNotebooks = iprot.readBool();
            setIncludeLinkedNotebooksIsSet(true);
          } else { 
            TProtocolUtil.skip(iprot, field.type);
          }
          break;
        case 9: // INCLUDE_EXPUNGED
          if (field.type == TType.BOOL) {
            this.includeExpunged = iprot.readBool();
            setIncludeExpungedIsSet(true);
          } else { 
            TProtocolUtil.skip(iprot, field.type);
          }
          break;
        case 10: // INCLUDE_NOTE_APPLICATION_DATA_FULL_MAP
          if (field.type == TType.BOOL) {
            this.includeNoteApplicationDataFullMap = iprot.readBool();
            setIncludeNoteApplicationDataFullMapIsSet(true);
          } else { 
            TProtocolUtil.skip(iprot, field.type);
          }
          break;
        case 12: // INCLUDE_RESOURCE_APPLICATION_DATA_FULL_MAP
          if (field.type == TType.BOOL) {
            this.includeResourceApplicationDataFullMap = iprot.readBool();
            setIncludeResourceApplicationDataFullMapIsSet(true);
          } else { 
            TProtocolUtil.skip(iprot, field.type);
          }
          break;
        case 13: // INCLUDE_NOTE_RESOURCE_APPLICATION_DATA_FULL_MAP
          if (field.type == TType.BOOL) {
            this.includeNoteResourceApplicationDataFullMap = iprot.readBool();
            setIncludeNoteResourceApplicationDataFullMapIsSet(true);
          } else { 
            TProtocolUtil.skip(iprot, field.type);
          }
          break;
        case 11: // REQUIRE_NOTE_CONTENT_CLASS
          if (field.type == TType.STRING) {
            this.requireNoteContentClass = iprot.readString();
          } else { 
            TProtocolUtil.skip(iprot, field.type);
          }
          break;
        default:
          TProtocolUtil.skip(iprot, field.type);
      }
      iprot.readFieldEnd();
    }
    iprot.readStructEnd();
    validate();
  }

  public void write(TProtocol oprot) throws TException {
    validate();

    oprot.writeStructBegin(STRUCT_DESC);
    if (isSetIncludeNotes()) {
      oprot.writeFieldBegin(INCLUDE_NOTES_FIELD_DESC);
      oprot.writeBool(this.includeNotes);
      oprot.writeFieldEnd();
    }
    if (isSetIncludeNoteResources()) {
      oprot.writeFieldBegin(INCLUDE_NOTE_RESOURCES_FIELD_DESC);
      oprot.writeBool(this.includeNoteResources);
      oprot.writeFieldEnd();
    }
    if (isSetIncludeNoteAttributes()) {
      oprot.writeFieldBegin(INCLUDE_NOTE_ATTRIBUTES_FIELD_DESC);
      oprot.writeBool(this.includeNoteAttributes);
      oprot.writeFieldEnd();
    }
    if (isSetIncludeNotebooks()) {
      oprot.writeFieldBegin(INCLUDE_NOTEBOOKS_FIELD_DESC);
      oprot.writeBool(this.includeNotebooks);
      oprot.writeFieldEnd();
    }
    if (isSetIncludeTags()) {
      oprot.writeFieldBegin(INCLUDE_TAGS_FIELD_DESC);
      oprot.writeBool(this.includeTags);
      oprot.writeFieldEnd();
    }
    if (isSetIncludeSearches()) {
      oprot.writeFieldBegin(INCLUDE_SEARCHES_FIELD_DESC);
      oprot.writeBool(this.includeSearches);
      oprot.writeFieldEnd();
    }
    if (isSetIncludeResources()) {
      oprot.writeFieldBegin(INCLUDE_RESOURCES_FIELD_DESC);
      oprot.writeBool(this.includeResources);
      oprot.writeFieldEnd();
    }
    if (isSetIncludeLinkedNotebooks()) {
      oprot.writeFieldBegin(INCLUDE_LINKED_NOTEBOOKS_FIELD_DESC);
      oprot.writeBool(this.includeLinkedNotebooks);
      oprot.writeFieldEnd();
    }
    if (isSetIncludeExpunged()) {
      oprot.writeFieldBegin(INCLUDE_EXPUNGED_FIELD_DESC);
      oprot.writeBool(this.includeExpunged);
      oprot.writeFieldEnd();
    }
    if (isSetIncludeNoteApplicationDataFullMap()) {
      oprot.writeFieldBegin(INCLUDE_NOTE_APPLICATION_DATA_FULL_MAP_FIELD_DESC);
      oprot.writeBool(this.includeNoteApplicationDataFullMap);
      oprot.writeFieldEnd();
    }
    if (this.requireNoteContentClass != null) {
      if (isSetRequireNoteContentClass()) {
        oprot.writeFieldBegin(REQUIRE_NOTE_CONTENT_CLASS_FIELD_DESC);
        oprot.writeString(this.requireNoteContentClass);
        oprot.writeFieldEnd();
      }
    }
    if (isSetIncludeResourceApplicationDataFullMap()) {
      oprot.writeFieldBegin(INCLUDE_RESOURCE_APPLICATION_DATA_FULL_MAP_FIELD_DESC);
      oprot.writeBool(this.includeResourceApplicationDataFullMap);
      oprot.writeFieldEnd();
    }
    if (isSetIncludeNoteResourceApplicationDataFullMap()) {
      oprot.writeFieldBegin(INCLUDE_NOTE_RESOURCE_APPLICATION_DATA_FULL_MAP_FIELD_DESC);
      oprot.writeBool(this.includeNoteResourceApplicationDataFullMap);
      oprot.writeFieldEnd();
    }
    oprot.writeFieldStop();
    oprot.writeStructEnd();
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder("SyncChunkFilter(");
    boolean first = true;

    if (isSetIncludeNotes()) {
      sb.append("includeNotes:");
      sb.append(this.includeNotes);
      first = false;
    }
    if (isSetIncludeNoteResources()) {
      if (!first) sb.append(", ");
      sb.append("includeNoteResources:");
      sb.append(this.includeNoteResources);
      first = false;
    }
    if (isSetIncludeNoteAttributes()) {
      if (!first) sb.append(", ");
      sb.append("includeNoteAttributes:");
      sb.append(this.includeNoteAttributes);
      first = false;
    }
    if (isSetIncludeNotebooks()) {
      if (!first) sb.append(", ");
      sb.append("includeNotebooks:");
      sb.append(this.includeNotebooks);
      first = false;
    }
    if (isSetIncludeTags()) {
      if (!first) sb.append(", ");
      sb.append("includeTags:");
      sb.append(this.includeTags);
      first = false;
    }
    if (isSetIncludeSearches()) {
      if (!first) sb.append(", ");
      sb.append("includeSearches:");
      sb.append(this.includeSearches);
      first = false;
    }
    if (isSetIncludeResources()) {
      if (!first) sb.append(", ");
      sb.append("includeResources:");
      sb.append(this.includeResources);
      first = false;
    }
    if (isSetIncludeLinkedNotebooks()) {
      if (!first) sb.append(", ");
      sb.append("includeLinkedNotebooks:");
      sb.append(this.includeLinkedNotebooks);
      first = false;
    }
    if (isSetIncludeExpunged()) {
      if (!first) sb.append(", ");
      sb.append("includeExpunged:");
      sb.append(this.includeExpunged);
      first = false;
    }
    if (isSetIncludeNoteApplicationDataFullMap()) {
      if (!first) sb.append(", ");
      sb.append("includeNoteApplicationDataFullMap:");
      sb.append(this.includeNoteApplicationDataFullMap);
      first = false;
    }
    if (isSetIncludeResourceApplicationDataFullMap()) {
      if (!first) sb.append(", ");
      sb.append("includeResourceApplicationDataFullMap:");
      sb.append(this.includeResourceApplicationDataFullMap);
      first = false;
    }
    if (isSetIncludeNoteResourceApplicationDataFullMap()) {
      if (!first) sb.append(", ");
      sb.append("includeNoteResourceApplicationDataFullMap:");
      sb.append(this.includeNoteResourceApplicationDataFullMap);
      first = false;
    }
    if (isSetRequireNoteContentClass()) {
      if (!first) sb.append(", ");
      sb.append("requireNoteContentClass:");
      if (this.requireNoteContentClass == null) {
        sb.append("null");
      } else {
        sb.append(this.requireNoteContentClass);
      }
      first = false;
    }
    sb.append(")");
    return sb.toString();
  }

  public void validate() throws TException {
    // check for required fields
  }

}

